clear all;
close all;
I=double(imread('coins.png'));

[W,H]=size(I);

output_image=zeros(size(I));

% standard deviation
sigma=3;

patchRadius=ceil(3*sigma);
patchSize=(patchRadius+patchRadius+1)^2;
medInd=floor(patchSize/2)+1;

neighbor_array=zeros(patchSize);


% compute Gaussian Kernel and normalize
x = -patchRadius:1:patchRadius;
[Y,X] = meshgrid(x,x);
w = exp( -(X.^2+Y.^2)/(2*sigma^2) );
w = w / sum(w(:));

ind=1;

% sum over neighbor pixel 
sum_wf=0;

% iterate over all pixel 
for x=1:W    
    for y=1:H
        %iterate over patch neighborhood
        for x_=-patchRadius:patchRadius
            x_n=x+x_;
            % checking for boundaries
            if(0<x_n&&x_n<W)
                for y_=-patchRadius:patchRadius
                    y_n=y+y_;
                    if(0<y_n&&y_n<H)
                        % sum up weighted neighboring pixels 
                        sum_wf=sum_wf+w(patchRadius+1+x_,patchRadius+1+y_)*I(x_n,y_n);
                    end
                end
            end
        end
        output_image(x,y)=sum_wf;
        sum_wf=0;
        
    end
end

% Compute gradient magnitude
grad_im=sqrt(dxp(output_image).^2+dyp(output_image).^2);

% Display
subplot(1,3,1)
imshow(I,[]);
title('Input')
subplot(1,3,2)
imshow(output_image,[])
title('Convolved Image');
subplot(1,3,3)
imshow(grad_im,[])
title('Gradient of Convolved Image');



